<?php
// 2010-07-07 վ֮

function getAdminDir() {
	if (isAdminDir("dede")) {
		return "dede";
	}
	
	$handle = opendir('.');
	while ($file = readdir($handle)) {
		if (isAdminDir($file)) {
			return $file;
		}
	}
	
	return "dede";
}

function isAdminDir($dir) {
	$temp1 = $dir . "/inc/inc_archives_functions.php";
	$temp2 = $dir . "/inc/inc_admin_channel.php";
	$temp3 = $dir . "/makehtml_archives.php";
	
	if (is_file($temp1) && is_file($temp2) && is_file($temp3)) {
		return true;
	}
	
	return false;
}

define('DEDEADMIN', getAdminDir());
require_once('include/common.inc.php');
require_once(DEDEINC.'/userlogin.class.php');
header('Cache-Control:private');
$dsql->safeCheck = false;
$dsql->SetLongLink();

if (doUserLogin($U, $P) == false) {
	echo "102\r\n";
	exit();
}

$cuserLogin = new userLogin();

if ($A == "Validate") {
	doValidate();
} else if ($A == "ListColumns") {
	doListColumns();
} else if ($A == "AddArticle") {
	doAddArticle();
} else {
	echo "103\r\n";
}

$cuserLogin->exitUser();

function doValidate() {
	echo "100\r\n";
}

function doListColumns() {
	$columnString = listCategories(0, 0, 1);
	echo "100\r\n";
	echo "\r\n";
	echo $columnString;
}

function doAddArticle() {
	require_once(DEDEINC.'/customfields.func.php');
	require_once(DEDEADMIN.'/inc/inc_archives_functions.php');

	require_once(DEDEINC.'/image.func.php');
	require_once(DEDEINC.'/oxwindow.class.php');
	
	global $cfg_arcautosp, $cfg_arcautosp_size;
	
	$channelid = 1;
	$title = $Title;
	$shorttitle = "";
	$tags = "";
	$source = $Source;
	$writer = "δ֪";
	$typeid = $ColumnId;
	$keywords = $Keyword;
	$description = $Description;
	$body = $Content;
	$pubdate = $PublishedDate;
	$notpost = 0;
	$sortup = 0;
	$arcrank = 0;
	$ishtml = 1;
	
	$flag = isset($flags) ? join(',',$flags) : '';
	$notpost = isset($notpost) && $notpost == 1 ? 1: 0;
	
	if(empty($typeid2)) $typeid2 = '';
	if(!isset($autokey)) $autokey = 0;
	if(!isset($remote)) $remote = 0;
	if(!isset($dellink)) $dellink = 0;
	if(!isset($autolitpic)) $autolitpic = 0;
	if(empty($click)) $click = ($cfg_arc_click=='-1' ? mt_rand(50, 200) : $cfg_arc_click);
	
	if(empty($typeid))
	{
		echo "104\r\n";
		echo "δָĵĿ\r\n";
		exit();
	}
	if(!CheckChannel($typeid,$channelid))
	{
		echo "104\r\n";
		echo "ѡĿģͲ\r\n";
		exit();
	}
	
	//Աݽд
	if(empty($writer))$writer=$cuserLogin->getUserName();
	if(empty($source))$source='δ֪';
	$pubdate = GetMkTime($pubdate);
	$senddate = time();
	$sortrank = AddDay($pubdate,$sortup);
	$ismake = $ishtml==0 ? -1 : 0;
	$title = ereg_replace('"', '', $title);
	$title = htmlspecialchars(cn_substrR($title,$cfg_title_maxlen));
	$shorttitle = cn_substrR($shorttitle,36);
	$color =  cn_substrR($color,7);
	$writer =  cn_substrR($writer,20);
	$source = cn_substrR($source,30);
	$description = cn_substrR($description,$cfg_auot_description);
	$keywords = cn_substrR($keywords,60);
	$filename = trim(cn_substrR($filename,40));
	$userip = GetIP();

	$cuserLogin = new userLogin();
	$adminid = $cuserLogin->getUserID();

	//ϴͼ
	if(empty($ddisremote))
	{
		$ddisremote = 0;
	}
	
	$litpic = GetDDImage('none', $picname, $ddisremote);

	//ĵID
	$arcID = GetIndexKey($arcrank,$typeid,$sortrank,$channelid,$senddate,$adminid);
    
	if(empty($arcID))
	{
		echo "105\r\n";
		echo "޷޷к\r\n";
		exit();
	}
	if(trim($title) == '')
	{
		echo "104\r\n";
		echo "ⲻΪա\r\n";
		exit();
	}

	//bodyֶԶժҪԶȡͼ
	$body = AnalyseHtmlBody($body,$description,$litpic,$keywords,'htmltext');

	//Զҳ
	//if($sptype=='auto')
	if ($cfg_arcautosp=='Y')
	{
		$body = SpLongBody($body,$cfg_arcautosp_size*1024,"#p#ҳ#e#");
	}

	//ӱ
	$inadd_f = $inadd_v = '';
	if(!empty($dede_addonfields))
	{
		$addonfields = explode(';',$dede_addonfields);
		if(is_array($addonfields))
		{
			foreach($addonfields as $v)
			{
				if($v=='') continue;
				$vs = explode(',',$v);
				if($vs[1]=='htmltext'||$vs[1]=='textdata')
				{
					${$vs[0]} = AnalyseHtmlBody(${$vs[0]},$description,$litpic,$keywords,$vs[1]);
				}
				else
				{
					if(!isset(${$vs[0]})) ${$vs[0]} = '';
					${$vs[0]} = GetFieldValueA(${$vs[0]},$vs[1],$arcID);
				}
				$inadd_f .= ','.$vs[0];
				$inadd_v .= " ,'".${$vs[0]}."' ";
			}
		}
	}

	//ͼƬĵԶ
	if($litpic!='' && !ereg('p',$flag))
	{
		$flag = ($flag=='' ? 'p' : $flag.',p');
	}
	if($redirecturl!='' && !ereg('j',$flag))
	{
		$flag = ($flag=='' ? 'j' : $flag.',j');
	}
	
	//תַĵǿΪ̬
	if(ereg('j', $flag)) $ismake = -1;

	//浽
	$query = "INSERT INTO `#@__archives`(id,typeid,typeid2,sortrank,flag,ismake,channel,arcrank,click,money,title,shorttitle,
    color,writer,source,litpic,pubdate,senddate,mid,notpost,description,keywords,filename,dutyadmin)
    VALUES ('$arcID','$typeid','$typeid2','$sortrank','$flag','$ismake','$channelid','$arcrank','$click','$money',
    '$title','$shorttitle','$color','$writer','$source','$litpic','$pubdate','$senddate',
    '$adminid','$notpost','$description','$keywords','$filename','$adminid');";

	if(!$dsql->ExecuteNoneQuery($query))
	{
		$gerr = $dsql->GetError();
		$dsql->ExecuteNoneQuery("Delete From `#@__arctiny` where id='$arcID'");
		echo "105\r\n";
		echo "ݱ浽ݿ `#@__archives` ʱϢύDedeCmsٷ".str_replace('"','',$gerr);
		echo "\r\n";
		exit();
	}

	//浽ӱ
	$cts = $dsql->GetOne("Select addtable From `#@__channeltype` where id='$channelid' ");
	$addtable = trim($cts['addtable']);
	if(empty($addtable))
	{
		$dsql->ExecuteNoneQuery("Delete From `#@__archives` where id='$arcID'");
		$dsql->ExecuteNoneQuery("Delete From `#@__arctiny` where id='$arcID'");
		echo "104\r\n";
		echo "ûҵǰģ[{$channelid}]Ϣ޷ɲ\r\n";
		exit();
	}
	$useip = GetIP();
	$templet = empty($templet) ? '' : $templet;
	$query = "INSERT INTO `{$addtable}`(aid,typeid,redirecturl,templet,userip,body{$inadd_f}) Values('$arcID','$typeid','$redirecturl','$templet','$useip','$body'{$inadd_v})";
	if(!$dsql->ExecuteNoneQuery($query))
	{
		$gerr = $dsql->GetError();
		$dsql->ExecuteNoneQuery("Delete From `#@__archives` where id='$arcID'");
		$dsql->ExecuteNoneQuery("Delete From `#@__arctiny` where id='$arcID'");
		echo "105\r\n";
		echo "ݱ浽ݿ⸽ӱ `{$addtable}` ʱϢύDedeCmsٷ".str_replace('"','',$gerr);
		echo "\r\n";
		exit();
	}

	//HTML
	InsertTags($tags,$arcID);
	$artUrl = MakeArt($arcID,true,true);
	if($artUrl=='')
	{
		$artUrl = $cfg_phpurl."/view.php?aid=$arcID";
	}
	ClearMyAddon($arcID, $title);
	

	makePrevNext($arcID, $typeid);
	makeIndex();
	makeChannel($typeid);
	
	echo "100\r\n\r\n";
}

function doUserLogin($userid, $pwd) {
	require_once(DEDEINC.'/userlogin.class.php');

	$admindirs = explode('/',str_replace("\\",'/',dirname(__FILE__)));
	$admindir = $admindirs[count($admindirs)-1];

	$cuserLogin = new userLogin($admindir);
	if (!empty($userid) && !empty($pwd)) {
		$res = $cuserLogin->checkUser($userid, $pwd);
		
		if($res==1) {
			$cuserLogin->keepUser();
			return true;
		} else{
			return false;
		}
	} else {
		return false;
	}
}

function listCategories($selid=0, $userCatalog=0, $channeltype=0) {
	global $dsql;

	$query = "Select id,reid,typename,ispart,channeltype From `#@__arctype` where ispart=0 order by sortrank asc ";

	$dsql->SetQuery($query);
	$dsql->Execute();

	$result = '';
	while($row=$dsql->GetObject())
	{
		$result .= $row->reid ." ". $row->id ." ". $row->typename ."\n";
	}

	return $result;
}

function makePrevNext($aid, $typeid) {
	global $dsql;
	require_once(DEDEINC.'/arc.archives.class.php');
	$aid = intval($aid);
	$preRow =  $dsql->GetOne("Select id From `#@__arctiny` where id<$aid And arcrank>-1 And typeid='$typeid' order by id desc");
	$nextRow = $dsql->GetOne("Select id From `#@__arctiny` where id>$aid And arcrank>-1 And typeid='$typeid' order by id asc");
	if(is_array($preRow))
	{
		$envs['aid'] = $preRow['id'];
		$arc = new Archives($preRow['id']);
		$arc->MakeHtml();
	}
	if(is_array($nextRow))
	{
		$envs['aid'] = $nextRow['id'];
		$arc = new Archives($nextRow['id']);
		$arc->MakeHtml();
	}
}

function makeChannel($typeid) {
	require_once(DEDEROOT."/data/cache/inc_catalog_base.inc");
	require_once(DEDEINC.'/arc.listview.class.php');
	require_once(DEDEINC."/arc.sglistview.class.php");
	
	$lv = new ListView($typeid);
	//$lv = new SgListView($typeid);
	$lv->MakeHtml();
	$lv->Close();
}

function makeIndex() {
	require_once(DEDEINC.'/arc.partview.class.php');
	global $_sys_globals,$envs,$cfg_df_style,$cfg_basedir,$cfg_templets_dir;
	$envs = $_sys_globals = array();
	$envs['aid'] = 0;
	$pv = new PartView();
	$row = $pv->dsql->GetOne('Select * From `#@__homepageset`');
	$templet = str_replace("{style}", $cfg_df_style, $row['templet']);
	//$homeFile = dirname(__FILE__).'/'.$row['position'];
	$homeFile = getAdminDir().'/'.$row['position'];
	$homeFile = str_replace("//", "/", str_replace("\\", "/", $homeFile));
	$fp = fopen($homeFile, 'w') or die("޷վҳ$homeFile λ");
	fclose($fp);
	$tpl = $cfg_basedir.$cfg_templets_dir.'/'.$templet;
	if(!file_exists($tpl))
	{
		$tpl = $cfg_basedir.$cfg_templets_dir.'/default/index.htm';
		if(!file_exists($tpl)) exit("޷ҵҳģ壺$tpl ");
	}
	$pv->SetTemplet($tpl);
	$pv->SaveToHtml($homeFile);
	$pv->Close();
}

?>