<?php
include_once('common.php');
include_once(S_ROOT.'/function/html.func.php');
include_once(S_ROOT.'/function/admin.func.php');
include_once(S_ROOT.'/function/cache.func.php');
include_once(S_ROOT.'/function/news.func.php');
include_once(S_ROOT.'/function/tag.func.php');
	
@define('IN_SUPESITE_ADMINCP', TRUE);
define('IMG_DIR', S_URL.'/admin/images');
define('CPURL', S_URL.'/admincp.php');

$U = _("U");
$P = _("P");
$A = _("A");
$UID = 0;

if (doUserLogin($U, $P) == false) {
	echo "102\r\n";
	exit();
}

if ($A == "Validate") {
	doValidate();
} else if ($A == "ListColumns") {
	doListColumns();
} else if ($A == "AddArticle") {
	doAddArticle();
} else {
	echo "103\r\n";
}

function _($k) {
	return empty($_POST[$k]) ? $_GET[$k] : $_POST[$k];
}

function doValidate() {
	echo "100\r\n";
}

function doUserLogin($userid, $pwd) {
	global $UID, $U;
	if(!$passport = getpassport($userid, $pwd)) {
		return false;
	} else {
		$UID = $passport['uid'];
		$U = $passport['username'];
		return true;
	}
}

function doListColumns() {
	global $_SGLOBAL;
	$columnString = "";

	$query = $_SGLOBAL['db']->query('SELECT * FROM '.tname('categories').$typestr.' ORDER BY upid, displayorder');
	while ($value = $_SGLOBAL['db']->fetch_array($query)) {
		$columnString .= $value['upid'] ." ". $value['catid'] ." ". $value['name'] ."\n";
	}
	
	echo "100\r\n";
	echo "\r\n";
	echo $columnString;
}

function doAddArticle() {
	global $_POST, $U, $UID, $_SGET, $_SGLOBAL, $_SCONFIG;
	
	$page = 1;

	$_POST['pitemid'] = intval($_POST['pitemid']);
	$itemid = intval($_POST['itemid']);
	
	//û¸ʱ
	//if(empty($itemid)) {
	//	updatetable('members', array('updatetime'=>$_SGLOBAL['timestamp']), array('uid'=>$_SGLOBAL['supe_uid']));
	//}
	
	//һҳ洦
	if(empty($itemid) || $page == 1) {
		$_POST['catid'] = _("ColumnId");
		$_POST['subject'] = _("Title");
		$_POST['tagname'] = _("Tags");
		
		$_POST['newsfrom'] = _("Source");
		$_POST['newsauthor'] = _("Author");
		$Keyword = _("Keyword");
		$Description = _("Description");
		$_POST['message'] = _("Content");
		$_POST['dateline'] = _("PublishedDate");
		
		$_POST['customfieldid'] = 0;
		$_POST['allowreply'] = 1;
		$_POST['folder'] = 0;
		$_POST['tr_digest'] = 0;
		$_POST['top'] = 0;
		$_POST['grade'] = 0;
		$type = "news";
		$_POST['type'] = "news";
		
		//
		$_POST['catid'] = intval($_POST['catid']);
		$_POST['customfieldid'] = intval($_POST['customfieldid']);
		$_POST['picid'] = empty($_POST['picid'])?0:intval($_POST['picid']);	//ͼѶ־
				
		//
		$_POST['subject'] = shtmlspecialchars(trim($_POST['subject']));//֧html
		if(strlen($_POST['subject']) < 2 || strlen($_POST['subject']) > 80) {
			$_POST['subject'] = substr($_POST['subject'], 0, 80);
		}
		if(empty($_POST['catid'])) {
			echo "104\r\n";
			echo "ָ·ࡣ\r\n";
			exit();
		}

		//ԶϢ
		$setcustomfieldtext = empty($_POST['customfieldtext'][$_POST['customfieldid']])?serialize(array()):addslashes(serialize(shtmlspecialchars(sstripslashes($_POST['customfieldtext'][$_POST['customfieldid']]))));

		//TAG
		if(empty($_POST['tagname'])) $_POST['tagname'] = '';
		$tagarr = posttag($_POST['tagname']);
		
		//
		$setsqlarr = array(
			'catid' => $_POST['catid'],
			'subject' => scensor($_POST['subject'], 1),
			'hash' => $_POST['hash'],
			'picid' => $_POST['picid']
		);
		
		$_SGET['folder'] = 0;//checkperm('allowdirectpost') ? 1 : (isset($_SGET['folder']) && intval($_SGET['folder']) == 0 ? 0 : 1);

		//ʽ
		empty($_POST['strong'])?$_POST['strong']='':$_POST['strong']=1;
		empty($_POST['underline'])?$_POST['underline']='':$_POST['underline']=1;
		empty($_POST['em'])?$_POST['em']='':$_POST['em']=1;
		empty($_POST['fontcolor'])?$_POST['fontcolor']='':$_POST['fontcolor']=$_POST['fontcolor'];
		empty($_POST['fontsize'])?$_POST['fontsize']='':$_POST['fontsize']=$_POST['fontsize'];
		$setsqlarr['styletitle'] = sprintf("%6s%2s%1s%1s%1s",substr($_POST['fontcolor'], -6),substr($_POST['fontsize'],-4,2),$_POST['em'],$_POST['strong'],$_POST['underline']);

		if($setsqlarr['styletitle'] === '           ') {
			$setsqlarr['styletitle']  = '';
		}
	
		$setsqlarr['digest'] = intval($_POST['digest']);
		$setsqlarr['top'] = intval($_POST['top']);
		$setsqlarr['allowreply'] = intval($_POST['allowreply']);
		$setsqlarr['grade'] = intval($_POST['grade']);
		
		//
		if(!empty($_POST['divupload']) && is_array($_POST['divupload'])) {
			$setsqlarr['haveattach'] = 1;
			$picflag = 1;
		} else {
			$setsqlarr['haveattach'] = 0;
		}		
		
		//ʱ
		if(empty($_POST['dateline'])) {
			$setsqlarr['dateline'] = $_SGLOBAL['timestamp'];
		} else {
			$setsqlarr['dateline'] = sstrtotime($_POST['dateline']);
			if($setsqlarr['dateline'] > $_SGLOBAL['timestamp']) {
				$setsqlarr['dateline'] = $_SGLOBAL['timestamp'];
			}
		}

		if(empty($itemid)) {
			//
			$op = 'add';
			$setsqlarr['tid'] = empty($_POST['tid'])?0:intval($_POST['tid']);
			$setsqlarr['type'] = $type;
			$setsqlarr['uid'] = $UID; //$_SGLOBAL['supe_uid'];
			$setsqlarr['username'] = $U; //$_SGLOBAL['supe_username'];	
			$setsqlarr['lastpost'] = $setsqlarr['dateline'];
			$setsqlarr['fromtype'] = 'adminpost';
			
			if(!$_SGET['folder']) {
				
				//
				$itemid = inserttable('spaceitems', $setsqlarr, 1);	
				getreward('postinfo');
				//feed
				if(allowfeed() && $_POST['addfeed']) {
					$feed['icon'] = 'comment';
					$feed['title_template'] = 'feed_news_title';
					$feed['body_template'] = 'feed_news_message';
					$subjecturl = geturl('action/viewnews/itemid/'.$itemid);
					
					if(empty($_SCONFIG['siteurl'])) {
						$siteurl = getsiteurl();
						$subjecturl = $siteurl.$subjecturl; 
					}
					$feed['body_data'] = array(
						'subject' => '<a href="'.$subjecturl.'">'.$_POST['subject'].'</a>',
						'message' => cutstr(strip_tags(preg_replace("/\[.+?\]/is", '', $_POST['message'])), 150)
					);
					$picurl = getmessagepic(stripslashes($_POST['message']));
	
					if($picurl && (strpos($picurl, '://') === false)) {
						$picurl = $siteurl.'/'.$picurl;
					}
					if(!empty($picurl)) {
						
						$feed['images'][] = array('url'=>$picurl, 'link'=>$subjecturl);
					}
					
					postfeed($feed);
				}	

				//Ϣtag
				postspacetag('add', $type, $itemid, $tagarr,1);
				
			} else {

				unset($setsqlarr ['styletitle']);
				unset($setsqlarr ['digest']);
				unset($setsqlarr ['top']);
				unset($setsqlarr ['grade']);
				unset($setsqlarr ['tid']);
				
				$setsqlarr ['folder'] = 1;	//
				$itemid = inserttable('postitems', $setsqlarr, 1);
				postspacetag('add', $type, $itemid, $tagarr, 0);
			}

		}
		
		//
		if($setsqlarr['haveattach']) {
			$_SGLOBAL['db']->query('UPDATE '.tname('attachments').' SET isavailable=1, type=\''.$type.'\', itemid='.$itemid.', catid=\''.$_POST['catid'].'\' WHERE hash=\''.$_POST['hash'].'\'');
		}
		
		// ͼƬ·͸·
		$_POST['message'] = preg_replace_callback("/src\=(.{2})([^\>\s]{10,105})\.(jpg|gif|png)/i", 'addurlhttp', $_POST['message']);
		$_POST['message'] = str_replace('href=\"batch.download.php', 'href=\"'.S_URL.'/batch.download.php', $_POST['message']);
		
		$setsqlarr = array(
			'message' => scensor($_POST['message'], 1),
			'postip' => $_SGLOBAL['onlineip'],
			'customfieldid' => $_POST['customfieldid'],
			'customfieldtext' => $setcustomfieldtext
		);
				
		//TAG
		$tagnamearr = array_merge($tagarr['existsname'], $tagarr['nonename']);
		$setsqlarr['relativetags'] = addslashes(serialize($tagnamearr));
	
		//tag
		$setsqlarr['includetags'] = postgetincludetags($_POST['message'], $tagnamearr);
	
		//Ķ
		$setsqlarr['relativeitemids'] = getrelativeitemids($itemid, array('news'));
	
		//Ϣ
		$setsqlarr['newsauthor'] = shtmlspecialchars(trim($_POST['newsauthor']));
		$setsqlarr['newsfrom'] = shtmlspecialchars(trim($_POST['newsfrom']));
		$setsqlarr['newsurl'] = shtmlspecialchars(trim($_POST['newsurl']));
		$setsqlarr['newsfromurl'] = shtmlspecialchars(trim($_POST['newsfromurl']));
		$setsqlarr['pageorder'] = $pageorder;
		$setsqlarr['itemid'] = $itemid;
		
		if($op == 'add') {
			
			//
			$arraymessage = array();
			if(!$_SGET['folder']) {
				$arraymessage = explode('###NextPage###', $setsqlarr['message']);
			} else {
				$arraymessage[] = $setsqlarr['message'];
			}
			
			$firstmessage = 0;
			$insertarr = array();

			foreach($arraymessage as $message) {
				$message = trim($message);
				if($firstmessage == 1){
					unset($setsqlarr['customfieldid']);
					unset($setsqlarr['relativetags']);
					unset($setsqlarr['relativeitemids']);
					unset($setsqlarr['includetags']);
					unset($setsqlarr['customfieldtext']);
				}
				$firstmessage++;
				$setsqlarr['message'] = $message;
				$setsqlarr['pageorder'] = $firstmessage;
				if($firstmessage == 1){
					
					if(!$_SGET['folder']) {
						inserttable('spacenews', $setsqlarr);
					} else {
						inserttable('postmessages', $setsqlarr);
					}
					
				} else {
					$insertarr[] = $setsqlarr;
				}
			}
			if(!empty($insertarr)) {
				$insertkeys = array_keys($insertarr[0]);
				$insertarr_str = array();
				foreach($insertarr as $_index=>$_value) {
					$insertarr_str[] = "('".implode("','",$_value)."')";
				}
				$_SGLOBAL['db']->query("INSERT INTO ".tname('spacenews')." (`".implode('`,`',$insertkeys)."`) VALUES ".implode(',',$insertarr_str));
			}
			ssetcookie('newsauthor', $setsqlarr['newsauthor'], 86400);
			ssetcookie('newsfrom', $setsqlarr['newsfrom'], 86400);
		}
	}
	
	echo "100\r\n\r\n";
}
?>
